#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdio.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>
#include <stdlib.h>

int main(int argc, char *argv[])
{
  int udp, tcp, i; //sockets kai diktis
  int addr_len, count; //counters
  char data_out[1024], data_in[1024]; //data buffers
  struct sockaddr_in sid_in , sid_out; //domes sockets
  
  sid_in.sin_family = AF_INET; //ports meso diktiou
  sid_in.sin_addr.s_addr = INADDR_ANY; //akouei apo oles tis diefthinseis
  bzero(&(sid_in.sin_zero), sizeof(sid_in.sin_zero));
  addr_len = sizeof(struct sockaddr);

  for(i=1; i<argc-1; i++) { //gia kathe porta
    //dimiourgo UDP socket
    if ((udp = socket(AF_INET, SOCK_DGRAM, 0)) == -1) { //dimiourgia socket kai elegxos gia error
      perror("SERVER: Socket error\n");
      exit(1);
    }

    sid_in.sin_port = htons(atoi(argv[i])); //kathorismos port 
       
    //desmefsi tou socket gia tin antistixi porta
    if (bind(udp, (struct sockaddr *) &sid_in, sizeof(sid_in)) == -1)
    {
      perror("SERVER: Bind error\n");
    }

    //antallagi minimatwn
    bzero(&(data_in), sizeof(data_in)); //katharismos buffer
    count = recvfrom(udp, data_in, sizeof(data_in), 0, (struct sockaddr *) &sid_out, &addr_len); //ping
    printf("[%s:%d] %s [%d]\n", inet_ntoa(sid_out.sin_addr), ntohs(sid_in.sin_port), data_in, count); //ektiposi apotelesmatos
    bzero(&(data_out), sizeof(data_out)); //katharismos buffer
    strcpy(data_out,"pong"); //proetimasia minimatos pros apostoli
    sendto(udp, data_out, strlen(data_out), 0, (struct sockaddr *) &sid_out, sizeof(struct sockaddr)); //pong
    close(udp); //klisimo udp socket
  }  

  if ((udp = socket(AF_INET, SOCK_STREAM, 0)) == -1) { //dimourgia TCP socket kai elegxos gia sfalma
    perror("SERVER: Socket error\n");
    exit(1);
  }
  
  sid_in.sin_port = htons(atoi(argv[argc-1])); //kathorismos port

  if (bind(udp, (struct sockaddr *) &sid_in, sizeof(sid_in)) == -1) //desmefsi tou port kai elegxos
  {
      perror("SERVER: Bind error\n");
  }
  
  listen(udp,10); //perimenei sindesi
  tcp=accept(udp, (struct sockaddr *) &sid_out, &addr_len); //sindesi tcp me client
  bzero(&(data_in), sizeof(data_in)); //katharismos buffer
  count=read(tcp, data_in, sizeof(data_in)); //ping
  printf("[%s:%d] %s [%d]\n", inet_ntoa(sid_out.sin_addr), ntohs(sid_in.sin_port), data_in, count); //ektiposi apotelesmatos
  write(tcp,"welcome",7); //apostoli kalosorismatos
  close(udp); //apodesmefsi socket
  close(tcp); //apodesmefsi tcp port
  return 0;
}


